/*
 # This sample code is used to test the pH meter V1.0.
 # Editor : YouYou
 # Ver    : 1.0
 # Product: analog pH meter
 # SKU    : SEN0161
 #
 #Edited by Maciej Ropelewski for Mikrokontroler.pl
*/
#include "LiquidCrystal.h"
#define SensorPin A3  
#define Offset 0.00          
#define LED_R 13
#define LED_G 12
#define LED_B 11
#define samplingInterval 20
#define printInterval 800
#define ArrayLenth  40    //times of collection
int pHArray[ArrayLenth];   //Store the average value of the sensor feedback
int pHArrayIndex=0;    
LiquidCrystal lcd(8, 9, 4, 5, 6, 7);
void setup(void)
{
  pinMode(LED_R,OUTPUT);  
  pinMode(LED_G,OUTPUT); 
  pinMode(LED_B,OUTPUT); 
  //Serial.begin(9600);  
  //Serial.println("pH meter experiment!");    //Test the serial monitor
  lcd.begin(16,2);
}
void loop(void)
{
 
  static unsigned long samplingTime = millis();
  static unsigned long printTime = millis();
  static float pHValue,voltage;
  if(millis()-samplingTime > samplingInterval)
  {
      pHArray[pHArrayIndex++]=analogRead(SensorPin);
      if(pHArrayIndex==ArrayLenth)pHArrayIndex=0;
      voltage = avergearray(pHArray, ArrayLenth)*5.0/1024;
      pHValue = 3.5*voltage+Offset;
      samplingTime=millis();
  }
  if(millis() - printTime > printInterval)   //Every 800 milliseconds, print a numerical, convert the state of the LED indicator
  {
 /* Serial.print("Voltage:");
        Serial.print(voltage,2);
        Serial.print("    pH value: ");
  Serial.println(pHValue,2);
        digitalWrite(LED,digitalRead(LED)^1);
        printTime=millis();*/
        lcd.setCursor(0,0);
        lcd.print ("Pomiar pH: ");
        lcd.setCursor(0,1);
        lcd.print (pHValue); 
        
                
        if (pHValue > 6.5 & pHValue < 7,5) {
           digitalWrite(LED_R, 1);
           digitalWrite(LED_G, 0);
           digitalWrite(LED_B, 1);
        }

        if (pHValue <= 6.5) {
           digitalWrite(LED_R, 0);
           digitalWrite(LED_G, 1);
           digitalWrite(LED_B, 1);
        }
        
       if (pHValue >= 7.5){
           digitalWrite(LED_R, 1);
           digitalWrite(LED_G, 1);
           digitalWrite(LED_B, 0);
        }
  }
}
double avergearray(int* arr, int number){
  int i;
  int max,min;
  double avg;
  long amount=0;
  if(number<=0){
    Serial.println("Error number for the array to avraging!/n");
    return 0;
  }
  if(number<5){   //less than 5, calculated directly statistics
    for(i=0;i<number;i++){
      amount+=arr[i];
    }
    avg = amount/number;
    return avg;
  }else{
    if(arr[0]<arr[1]){
      min = arr[0];max=arr[1];
    }
    else{
      min=arr[1];max=arr[0];
    }
    for(i=2;i<number;i++){
      if(arr[i]<min){
        amount+=min;        //arr<min
        min=arr[i];
      }else {
        if(arr[i]>max){
          amount+=max;    //arr>max
          max=arr[i];
        }else{
          amount+=arr[i]; //min<=arr<=max
        }
      }//if
    }//for
    avg = (double)amount/(number-2);
  }//if
  return avg;
}
